from infi.shell.commands import commandgroup

@commandgroup(prefix="config", manifest=None)
class ConfigCommandsBase(object):
    """ Base class for configuration commands. """

    _BASE_URI = "config"

    def _get_config(self, _api):
        return _api.get(self._BASE_URI)

    def _get_param(self, _api, category, param):
        return _api.get("{}/{}/{}".format(self._BASE_URI, category, param))

    def _configure_param(self, _api, category, param, value, subject, value_name=None):
        if value_name is None:
            if isinstance(value, bool):
                value_name = "enable" if value else "disable"
            else:
                value_name = str(value)
        current_value = self._get_param(_api, category, param)
        if value == current_value:
            return '{} {} already set to "{}"'.format(subject, "are" if subject.endswith("s") else "is", value_name)
        _api.put("{}/{}/{}".format(self._BASE_URI, category, param), value)
        return '{} set to "{}"'.format(subject, value_name)

    def _get_category(self, _api, category):
        return _api.get("{}/{}".format(self._BASE_URI, category))

    def _configure_category(self, _api, category, value):
        _api.put("{}/{}".format(self._BASE_URI, category), value)
