from ..constants import ROOT_ROLE

class User(object):
    def __init__(self, username, roles):
        self.username = username
        self.roles = Roles(roles)
    def has_role(self, *roles):
        return self.roles.has_role(*roles)

class Roles(object):
    INFINIDAT = ROOT_ROLE
    ADMIN = 'ADMIN'
    POOLADMIN = 'POOL_ADMIN'
    TECHNICIAN = 'TECHNICIAN'
    READONLY = 'READ_ONLY'

    all = tuple(value for key, value in locals().iteritems() if key[0] != '_' and key.isupper())

    def __init__(self, roles):
        self.roles = tuple(role.upper() for role in roles)
    def has_role(self, *roles):
        return any(role.upper() in self.roles for role in roles)
    def is_infinidat(self):
        return self.has_role(self.INFINIDAT)
    def is_admin(self):
        return self.has_role(self.ADMIN)
    def __repr__(self):
        return 'Roles({})'.format(", ".join('"{}"'.format(self.roles)))
    def __str__(self):
        return '<Roles: {}>'.format(", ".join(self.roles))
