from infi.shell.commands import commandgroup, command, magic

from ... import debug
from ...version import VERSION
from ..renderer import toggle_csv_mode
from .. import raw_mode

@commandgroup
class InfiniboxMagicCommands(object):
    @magic
    @command(
        description="Displays the version of the InfiniShell client",
        )
    def version(self, _api):
        return VERSION
    @magic
    @command(
        description="Use %debug to toggle debug output.",
        )
    def debug(self, _api):
        if debug.is_on():
            debug.off()
        else:
            debug.on()
        return "Debug output {}. \n\nUse %debug again to {} debug output." \
               .format("enabled" if debug.is_on() else "disabled", "disable" if debug.is_on() else "enable")
    @magic
    @command(
        description="Use %raw to toggle raw API output.",
        )
    def raw(self, _api):
        raw_mode.toggle()
        if raw_mode.is_on():
            raw_mode.toggle_message()
        return "Raw mode {}\n\nUse %raw again to {} raw API output" \
               .format("enabled" if raw_mode.is_on() else "disabled", "disable" if raw_mode.is_on() else "enable")
    @magic
    @command(
        description="Displays the name of the active user",
        )
    def user(self, _api):
        return _api.get_username()
    @magic
    @command(
        description="Use %csv to toggle CSV output.",
        )
    def csv(self, _api):
        if toggle_csv_mode():
            return "CSV output enabled\n\nUse %csv again to disable csv output"
        return "CSV output disabled\n\nUse %csv again to enable csv output"
