from . import EntityCommands
from infi.shell.commands import commandgroup, command
from .types import Name, SnapSet

@commandgroup(prefix="snapset", provides=(SnapSet,))
class SnapSetCommands(EntityCommands):
    ENTITY_TYPE = SnapSet
    @command(types=(SnapSet, Name, Name))
    def clone(self, _api, snapset, name, suffix=None):
        props = dict(snapset=snapset, name=name, suffix=suffix)
        return _api.post("consgroups", self._filter_properties(props))
    @command(types=(SnapSet,))
    def disband(self, _api, snapset):
        return self._update(_api, snapset, "Disbanded", snapshots=[])
    @command(types=(SnapSet,))
    def delete(self, _api, snapset):
        return self._delete(_api, snapset)
    @command(types=(SnapSet, Name))
    def rename(self, _api, snapset, new_name):
        return self._rename(_api, snapset, new_name)
    @command(types=(SnapSet,))
    def query(self, _api, snapset=None):
        return self._query(_api, snapset)

